---
title: CSS Containment
slug: Web/CSS/CSS_Containment
tags:
  - CSS
  - CSS Containment
  - Guide
  - Paint
  - Performance
---
<p>{{CSSRef}}<br>
The aim of the CSS Containment specification is to improve performance of web pages by allowing developers to isolate a subtree of the page from the rest of the page. If the browser knows that a part of the page is independent, rendering can be optimized and performance improved. The specification defines a single CSS property {{cssxref("contain")}}. This document describes the basic aims of the specification.</p>

<h2 id="Basic_example">Basic example</h2>

<p>Many webpages contain a number of sections which are independent of each other. For example a listing of article headlines and content, as in the mark-up below.</p>

<pre class="brush: html notranslate">&lt;h1&gt;My blog&lt;/h1&gt;
&lt;article&gt;
  &lt;h2&gt;Heading of a nice article&lt;/h2&gt;
  &lt;p&gt;Content here.&lt;/p&gt;
&lt;/article&gt;
&lt;article&gt;
  &lt;h2&gt;Another heading of another article&lt;/h2&gt;
  &lt;p&gt;More content here.&lt;/p&gt;
&lt;/article&gt;</pre>

<p>Each article has the {{cssxref("contain")}} property with a value of <code>content</code> applied in the CSS.</p>

<pre class="brush: css notranslate">article {
  contain: content;
}</pre>

<p>Each article is independent of the other articles on the page, and so they have been given <code>contain: content</code> in order to indicate to the browser that this is the case. The browser can then use this information to make decisions about how to render the content. For example, it might not render articles that are outside the viewable area.</p>

<p>If we give each <code>&lt;article&gt;</code> the <code>contain</code> property with a value of <code>content</code>, when new elements are inserted the browser understands it does not need to relayout or repaint any area outside of the containing element's subtree, although if the <code>&lt;article&gt;</code> is styled such that its size depends on its contents (e.g. with <code>height: auto</code>), then the browser may need to account for its size changing).</p>

<p>We have told it by way of the <code>contain</code> property that each article is independent.</p>

<p>The <code>content</code> value is shorthand for <code>contain: layout paint</code>. It tells the browser that the internal layout of the element is totally separate from the rest of the page, and that everything about the element is painted inside its bounds. Nothing can visibly overflow.</p>

<p>This information is something that is usually known, and in fact quite obvious, to the web developer creating the page. However browsers cannot guess at your intent and cannot assume that an article will be entirely self-contained. Therefore this property gives you a nice way to explain to the browser this fact, and allow it to make performance optimizations based on that knowledge.</p>

<h2 id="Key_concepts_and_terminology">Key concepts and terminology</h2>

<p>This specification defines only one property, the {{cssxref("contain")}} property. The values for this property indicate the type of containment that you want to apply to that element.</p>

<h3 id="Layout_containment">Layout containment</h3>

<pre class="brush: css notranslate">article {
  contain: layout;
}</pre>

<p>Layout is normally scoped to the entire document, which means that if you move one element the entire document needs to be treated as if things could have moved anywhere. By using <code>contain: layout</code> you can tell the browser it only needs to check this element — everything inside the element is scoped to that element and does not affect the rest of the page, and the containing box establishes an independent formatting context.</p>

<p>In addition:</p>

<ul>
	<li><code>float</code> layout will be performed independently.</li>
	<li>Margins won't collapse across a layout containment boundary</li>
	<li>The layout container will be a containing block for <code>absolute</code>/<code>fixed</code> position descendants.</li>
	<li>The containing box creates a stacking context, therefore {{cssxref("z-index")}} can be used.</li>
</ul>

<h3 id="Paint_containment">Paint containment</h3>

<pre class="brush: css notranslate">article {
  contain: paint;
}</pre>

<p>Paint containment essentially clips the box to the padding edge of the principal box. There can be no visible overflow. The same things are true for <code>paint</code> containment as <code>layout</code> containment (see above).</p>

<p>Another advantage is that if the containing box is offscreen, the browser does not need to paint its contained elements — these must also be offscreen as they are contained completely by that box.</p>

<h3 id="Size_containment">Size containment</h3>

<pre class="brush: css notranslate">article {
  contain: size;
}</pre>

<p>Size containment does not offer much in the way of performance optimizations when used on its own. However, it means that the size of the element's children cannot affect the size of the element itself — its size is computed as if it had no children.</p>

<p>If you turn on <code>contain: size</code> you need to also specify the size of the element you have applied this to. It will end up being zero-sized in most cases, if you don't manually give it a size.</p>

<h3 id="Style_containment">Style containment</h3>

<pre class="brush: css notranslate">article {
  contain: style;
}</pre>

<p>Despite the name, style containment does not provide scoped styles such as you would get with the <a href="/en-US/docs/Web/Web_Components/Using_shadow_DOM">Shadow DOM</a>. The main use case is to prevent situations where a <a href="/en-US/docs/Web/CSS/CSS_Lists_and_Counters/Using_CSS_counters">CSS Counter</a> could be changed in an element, which could then affect the rest of the tree. </p>

<p>Using <code>contain: style</code> would ensure that the {{cssxref("counter-increment")}} and {{cssxref("counter-set")}} properties created new counters scoped to that subtree only.</p>

<div class="notecard note">
<p><strong>Note</strong>: <code>style</code> containment is "at-risk" in the spec and may not be supported everywhere (it's not currently supported in Firefox).</p>
</div>

<h3 id="Special_values">Special values</h3>

<p>There are two special values of contain:</p>

<ul>
	<li><code>content</code></li>
	<li><code>strict</code></li>
</ul>

<p>We encountered the first in the example above. Using <code>contain: content</code> turns on <code>layout</code> and <code>paint</code> containment. The specification describes this value as being "reasonably safe to apply widely". It does not apply <code>size</code> containment, so you would not be at risk of a box ending up zero-sized due to a reliance on the size of its children.</p>

<p>To gain as much containment as possible use <code>contain: strict</code>, which behaves the same as <code>contain: size layout paint</code>, or perhaps the following to also add <code>style</code> containment in browsers that support it:</p>

<pre class="brush: css notranslate">contain: strict;
contain: strict style;</pre>

<h2 id="Reference">Reference</h2>

<h3 id="CSS_Properties">CSS Properties</h3>

<ul>
	<li>{{cssxref("contain")}}</li>
	<li>{{cssxref("content-visibility")}}</li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('CSS Containment 2', '#contain-property', 'contain')}}</td>
			<td>{{Spec2('CSS Containment 2')}}</td>
			<td>Added <code>style</code> keyword</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.contain")}}</p>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("css.properties.content-visibility")}}</p>

<h2 id="External_resources">External resources</h2>

<ul>
	<li><a href="https://blogs.igalia.com/mrego/2019/01/11/an-introduction-to-css-containment/">An Introduction to CSS Containment</a></li>
	<li><a href="https://dev.opera.com/articles/css-will-change-property">Everything You Need to Know About the CSS <code>will-change</code> Property</a></li>
</ul>
